## $Id$
## $Source$
##

%define name	ace
%define Name	ACE
%define version	5.4.4
%define release	1mdk

%define lib_major	5
# %define lib_name_orig	%mklibname %{name}
%define lib_name_orig	lib%{name}
%define lib_name	%{lib_name_orig}%{lib_major}

Summary:	ADAPTIVE Communication Environment
Name:		%{name}
Version:	%{version}
Release:	%{release}
Epoch:		0
URL:		http://www.cs.wustl.edu/~schmidt/ACE.html
Source0:	http://deuce.doc.wustl.edu/%{Name}.tar.bz2
# Patch0:		ACE-build.patch.bz2
License:	BSD-style
Group:		System/Libraries
BuildRequires:	openssl-devel
Buildroot:	%{_tmppath}/%{name}-%{version}-%{release}-root

%description
The ADAPTIVE Communication Environment (ACE) is a freely available,
open-source object-oriented (OO) framework that implements many core
patterns for concurrent communication software. ACE provides a rich set
of reusable C++ wrapper facades and framework components that perform
common communication software tasks across a range of OS platforms. The
communication software tasks provided by ACE include event
demultiplexing and event handler dispatching, signal handling, service
initialization, interprocess communication, shared memory management,
message routing, dynamic (re)configuration of distributed services,
concurrent execution and synchronization.

%package -n %{lib_name}
Summary:        Main library for ACE (ADAPTIVE Communication Environment)
Group:          System/Libraries

%description -n %{lib_name}
This package contains the libraries needed to run programs dynamically linked
with ACE (ADAPTIVE Communication Environment).

%package -n %{lib_name}-devel
Group:		Development/C++
Summary:	Shared libraries and header files for ACE (ADAPTIVE Communication Environment)
Provides:	%{name}-devel
Provides:	lib%{name}-devel
Provides:       gperf-ace
Requires:	%{lib_name} = %{epoch}:%{version}
Requires:	openssl-devel

%description -n %{lib_name}-devel
The %{name} package contains the shared libraries and header files needed for
developing ACE (ADAPTIVE Communication Environment) applications.

%package -n %{lib_name}-doc
Group:		Books/Howtos
Summary:        Documentation and examples for ACE (ADAPTIVE Communication Environment)

%description -n %{lib_name}-doc
Documentation and examples for ACE (ADAPTIVE Communication Environment).

%prep
%setup -q -n ACE_wrappers
# %patch0 -p1

%build
# autoreconf -f -i
mkdir -p objdir
cd objdir
ln -s ../configure
# %configure --with-gperf=no
%configure
make
cd ..

%install
rm -rf $RPM_BUILD_ROOT

cd objdir
%makeinstall_std

# The install script is incomplete (to be polite)
cd ..

# gperf is provided by a different rpm
mv $RPM_BUILD_ROOT%{_bindir}/gperf $RPM_BUILD_ROOT%{_bindir}/gperf-ace
cat > README-gperf.Mdk << EOT
ACE provides its own version of gperf renamed gperf-ace to avoid a conflict
with the gperf rpm. To use this program, you must define 
ACE_GPERF="%{_bindir}/gperf-ace" at compile time
EOT

# man and info pages
%__install -D -m 644 apps/gperf/gperf.info \
        $RPM_BUILD_ROOT%{_infodir}/gperf-ace.info
%__install -D -m 644 apps/gperf/gperf.1 \
        $RPM_BUILD_ROOT%{_mandir}/man1/gperf-ace.1

# ACE.pc is in the wrong place
%__mv $RPM_BUILD_ROOT%{_libdir}/prefix/%{Name}.pc \
       $RPM_BUILD_ROOT%{_libdir}/pkgconfig
%__rm -fR $RPM_BUILD_ROOT%{_libdir}/prefix

# Shameless adaptation from Debian rules
install -m 755 bin/generate_export_file.pl $RPM_BUILD_ROOT%{_bindir}

files=`grep -lr defined.*ACE_TEMPLATES_REQUIRE_SOURCE ace | sed -e 's/^\.//' -e 's/.h$/.cpp/'`
for i in $files ; do
    if [ ! -f $RPM_BUILD_ROOT%{_includedir}/$i ] ; then
        install -m 644 $i $RPM_BUILD_ROOT%{_includedir}/`dirname $i`
    fi
done

files=`grep -lr defined.*ACE_TEMPLATES_REQUIRE_SOURCE Kokyu | sed -e 's/^\.//' -e 's/.h$/.cpp/'`
for i in $files ; do
    if [ ! -f $RPM_BUILD_ROOT%{_includedir}/$i ] ; then
        install -m 644 $i $RPM_BUILD_ROOT%{_includedir}/`dirname $i`
    fi
done
# I hope that's all we need

# multiarch
%multiarch_includes $RPM_BUILD_ROOT%{_includedir}/ace/config-borland-common.h
%multiarch_includes $RPM_BUILD_ROOT%{_includedir}/ace/config.h
%multiarch_includes $RPM_BUILD_ROOT%{_includedir}/ace/config-win32-common.h
%multiarch_includes $RPM_BUILD_ROOT%{_includedir}/ace/config-win32-ghs.h
%multiarch_includes $RPM_BUILD_ROOT%{_includedir}/ace/config-win32-visualage.h


%clean
rm -rf $RPM_BUILD_ROOT

%files -n %{lib_name}
%defattr(-,root,root)
%doc ACE-INSTALL ACE-INSTALL.html AUTHORS ChangeLog COPYING FAQ PROBLEM-REPORT-FORM README THANKS VERSION
%{_libdir}/*.so.*

%files -n %{lib_name}-devel
%defattr(-,root,root)
%doc README-gperf.Mdk
%{_bindir}/*
%{_mandir}/man1/*
%{_infodir}/*
%dir %{_includedir}/%{name}
%dir %{_includedir}/ACEXML
%dir %{_includedir}/Kokyu
%{_includedir}/%{name}/*
%multiarch %{multiarch_includedir}/*
%{_includedir}/ACEXML/*
%{_includedir}/Kokyu/*
%{_libdir}/*.so
%{_libdir}/*.*a
#%{_libdir}/*.sh
%{_libdir}/pkgconfig/*

%files -n %{lib_name}-doc
%defattr(0644,root,root,0755)
%doc docs examples

%post -n %{lib_name} -p /sbin/ldconfig
%postun -n %{lib_name} -p /sbin/ldconfig

%changelog
* Thu Mar 17 2005 Lenny Cartier <lenny@mandrakesoft.com> 0:5.4.4-1mdk
- from : Eric Leroy <eric_leroy@trimble.com> :
	- New version (from configure script).
	- Includes gperf-ace to avoid conflict with gperf rpm (cf README-gperf.Mdk).
	- Man and info page.
	- multiarch.
	- Split docs and examples.

* Wed Feb 09 2005 Lenny Cartier <lenny@mandrakesoft.com> 0:5.4-4mdk
- from Eric Leroy <eric_leroy@trimble.com> : 
	- Use autoreconf after patching Makefile.am
	- Use a configure symlink for spec file portablility.
	- Use --with-gperf=no since gperf is in a separate rpm.
	- QoS is disabled by default (does not compile).

* Thu Jul 22 2004 Michael Scherer <misc@mandrake.org> 0:5.4-3mdk 
- rebuild for new gcc, remove libtool hack

* Sat Feb 21 2004 David Walluck <walluck@linux-mandrake.com> 0:5.4-2mdk
- bzip2 source and patch
- apparently `make install' doesn't install all of the header files

* Sat Jan 31 2004 David Walluck <walluck@linux-mandrake.com> 0:5.4-1mdk
- release
